%define ALD_Ver		1.2.4
%define X11_Version	7.7
%define X11_Release	4
%define USE_ProtoBinDir 1


Name:         libX11
Version:      1.6.2
Release:      0

License:      The Xorg Project
Summary:      Xorg X Library
Group:        Development/Libraries

Source: %{name}-%{version}.tar.xz
Source1: CROSS-X11.sh

%define DestDir		/X11/%{X11_Version}-%{X11_Release}
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%define _prefix /usr/X11R%{X11_Version}
%define _libdir	%{_prefix}/%{_lib}
%define protoPrefix /var/tmp/X11R%{X11_Version}-%{X11_Release}/%{TO_ARCH}
%define protoBinDir %{protoPrefix}/bin
%define protoDir %{protoPrefix}%{_prefix}

%define _defaultdocdir	%{_prefix}/share/doc
%define _mandir %{_prefix}/man

%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin
%define target_  %{target}-
%define hosttarget --host=%{target}

%define cross_prefix	%{csysdir}%{_prefix}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}
%define hosttarget %{nil}

%endif # !_CROSS

%if %{USE_ProtoBinDir}
%define __os_install_post %{nil}
%endif

%define docdir		%{_defaultdocdir}/%{name}

# ------------------- description ------------------------------------
%description
Xorg X Library
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package devel-man3
Summary:      man3 for Development
Group:        Development/Libraries
%description devel-man3
man3 for Development
#-------------------------------
%package doc
Summary:      Doc for %{name}
Group:        Documentation
%description doc
doc for %{name}
#-------------------------------
%package doc-devel
Summary:      Doc build data for X11
Group:        Development/Libraries
%description doc-devel
Doc build data for X11
#-------------------------------
%package locale
Summary:      locale
Group:        Applications/Languages
%description locale
Locale
#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries
# --------------------------------------
%package %{TO_ARCH}-doc
Summary:      %{name} Cross-%{TO_ARCH} doc
Group:        Development/Libraries
%description %{TO_ARCH}-doc
%{name} Cross-%{TO_ARCH} doc

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

# force no -rpath
sed -i s:"/lib /usr/lib \$lt_ld_extra":"/lib /usr/lib %{_libdir} \$lt_ld_extra": configure

sed -i s:"@locales@":"C en_US.UTF-8 iso8859-1 iso8859-15": specs/i18n/compose/Makefile.in
# ------------------- Build ------------------------------------------
%Build
CPATH=
%if %{_CROSS}
CPATH="%{csysbindir}:"
export GCC_NoHostPath=d
%endif
%if %{USE_ProtoBinDir}
CPATH="$CPATH%{protoBinDir}:"
%endif
export PATH=$CPATH$PATH:/opt/perl/bin

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -fPIC -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
%if %{_target_cpu} == "armv7l"
OPTFLAGS="-O2 -fPIC -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%else
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif
%endif

LDFLAGS=
%if %{USE_ProtoBinDir}
PKG_CONFIG_PATH="%{protoPrefix}%{_libdir}/pkgconfig:%{protoPrefix}/usr/lib/pkgconfig:%{protoPrefix}/usr/share/pkgconfig"
export PKG_CONFIG_PATH 
LDFLAGS="-L%{protoPrefix}%{_libdir}"
%endif

CXXFLAGS="$OPTFLAGS -D_GNU_SOURCE"
CFLAGS="$OPTFLAGS -D_GNU_SOURCE -std=gnu99"

export CFLAGS CXXFLAGS LDFLAGS

./configure --build=%{_build} %{hosttarget} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--datarootdir=%{_libdir} \
	--mandir=%{_mandir} \
	--localstatedir=/var \
	--sysconfdir=/etc \
	--docdir=%{docdir} \
	--disable-libtool-lock \
	--disable-static \
	--disable-ipv6 \
	--disable-loadable-i18n \
	--disable-xf86bigfont \
	&>Fconfigure_log.txt

make -j 2 &>Fmake_log.txt

# ------------------- Install ----------------------------------------
%Install
CPATH=
%if %{_CROSS}
CPATH="%{csysbindir}:"
export GCC_NoHostPath=d
%endif
%if %{USE_ProtoBinDir}
CPATH="$CPATH%{protoBinDir}:"
RPM_TMP_ROOT=$RPM_BUILD_ROOT/tmp
%else   # USE_ProtoBinDir
RPM_TMP_ROOT=$RPM_BUILD_ROOT
%endif
export PATH=$CPATH$PATH:/opt/perl/bin

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_TMP_ROOT%{docdir}

make DESTDIR=$RPM_TMP_ROOT install &>FInstall_log.txt
rm $RPM_TMP_ROOT%{_libdir}/*.la
cp AUTHORS COPYING README $RPM_TMP_ROOT%{docdir}/

%if %{USE_ProtoBinDir}
TARGET_PRFIX=%{_prefix}
RPM_TMP_ROOT=$RPM_BUILD_ROOT/tmp
TARGET_INSTDIR=$RPM_BUILD_ROOT%{csysdir}%{_prefix}
TARGET_NAME=%{target_}
TARGET_LIB=%{_lib}
export TARGET_PRFIX RPM_TMP_ROOT TARGET_INSTDIR TARGET_NAME TARGET_LIB

TARGET_ProtoDir=%{protoDir}
TARGET_CrossDir=%{csysdir}%{_prefix}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_ProtoDir TARGET_CrossDir MKCROSSDIR
%SOURCE1
%endif  # !USE_ProtoBinDir

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
  mv %{name}-devel-man3-$SE $DD/%{name}-devel-man3-$DE
  mv %{name}-doc-$SE $DD/%{name}-doc-$DE
  mv %{name}-doc-devel-$SE $DD/%{name}-doc-devel-$DE
  mv %{name}-locale-$SE $DD/%{name}-locale-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
  mv %{name}-%{TO_ARCH}-doc-$SE $DDC/%{name}-%{TO_ARCH}-doc-$DEC
%endif #BUILD_LOCAL_CROSS
popd
 

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------

%files
%{_libdir}/*.so.*
%{_libdir}/X11/XErrorDB
%{_libdir}/X11/Xcms.txt
%{_libdir}/X11/locale/C
%{_libdir}/X11/locale/en_US.UTF-8
%{_libdir}/X11/locale/iso8859-1
%{_libdir}/X11/locale/iso8859-15
%{_libdir}/X11/locale/compose.dir
%{_libdir}/X11/locale/locale.alias
%{_libdir}/X11/locale/locale.dir
%{docdir}/AUTHORS
%{docdir}/COPYING
%{docdir}/README
%{_mandir}/man5

%files devel
%{_includedir}
%{_libdir}/*.so
%{_libdir}/pkgconfig

%files devel-man3
%{_mandir}/man3

%files doc
%{docdir}/*/*.html
%{docdir}/*/*.svg
%{docdir}/i18n/*/*.html
%{docdir}/i18n/*/*.svg

%files doc-devel
%{docdir}/*/*.db
%{docdir}/*/*.xml
%{docdir}/i18n/*/*.db
%{docdir}/i18n/*/*.xml

%files locale
%{_libdir}/X11/locale
%exclude %{_libdir}/X11/locale/C
%exclude %{_libdir}/X11/locale/en_US.UTF-8
%exclude %{_libdir}/X11/locale/iso8859-1
%exclude %{_libdir}/X11/locale/iso8859-15
%exclude %{_libdir}/X11/locale/compose.dir
%exclude %{_libdir}/X11/locale/locale.alias
%exclude %{_libdir}/X11/locale/locale.dir

# ------------------- Cross Files ------------------------------------
%if %{BUILD_LOCAL_CROSS}

%Files %{TO_ARCH}
%{cross_libdir}
%{cross_includedir}

%files %{TO_ARCH}-doc
%{cross_docdir}
%{cross_mandir}

%endif #!BUILD_LOCAL_CROSS
